Attribute VB_Name = "TL50"

'predefine colors
Global Const TLDEFAULT_COLOR = &H1
Global Const TLTRANSPARENT_COLOR = &H2000000


' ItemType property constants
Global Const TLTYPE_NONE = &H0
Global Const TLTYPE_INT = &H494E
Global Const TLTYPE_LNG = &H4C4E
Global Const TLTYPE_SNG = &H534E
Global Const TLTYPE_STR = &H5354
Global Const TLTYPE_PIC = &H5450

' TListGetItemByXY function nType parameter constants
Global Const PTFIND_ITEM = 1
Global Const PTFIND_PIC = 2
Global Const PTFIND_TEXT = 4

' TListGetItemRect function nType parameter constants
Type RECT
        Left As Integer
        Top As Integer
        Right As Integer
        Bottom As Integer
End Type

Global Const TLGR_ITEM = &H1
Global Const TLGR_PLUSMINUS = &H2
Global Const TLGR_MARK = &H4
Global Const TLGR_PICTURE = &H8
Global Const TLGR_TEXT = &H10

' Error codes constants
Global Const TLERR_BADINDENTATION = 20101
Global Const TLERR_WRONPARAMS = 20102 ' Obselete
Global Const TLERR_ITEMNOTFOUND = 20103
Global Const TLERR_PARENTNOTEXPANDED = 20104
Global Const TLERR_INITFAULT = 20105
Global Const TLERR_CANNOTSHOW = 20106
Global Const TLERR_INVALIDSEPARATOR = 20107
Global Const TLERR_INVALIDTREEBUFFER = 20108
Global Const TLERR_BIGPICSIZE = 20109
Global Const TLERR_NOTHINGTOCOPY = 20110
Global Const TLERR_TOMANYITEMS = 20111
Global Const TLERR_TOMANYSUBITEMS = 20112
Global Const TLERR_INVALIDARGS = 20113

' TriggerEvents property constants
Global Const TL_TRIGGER_INITIAL = 0
Global Const TL_TRIGGER_COLLAPSE_FOR_ALL = 1

' ItemEditText property  constants
Global Const TL_EDITTEXT_CANCEL = &H0
Global Const TL_EDITTEXT_END = &H1
Global Const TL_EDITTEXT_BEGIN = &H2

' Clipboard property  constants
Global Const TL_CLP_COPY = 0
Global Const TL_CLP_COPYONE = 1
Global Const TL_CLP_COPYSUB = 2
Global Const TL_CLP_PASTEANDADD = 3
Global Const TL_CLP_PASTEANDINSERT = 4

' VScroll & HScroll ScrollCode parameter constants
Global Const TL_SB_LINEUP = 0
Global Const TL_SB_LINEDOWN = 1
Global Const TL_SB_PAGEUP = 2
Global Const TL_SB_PAGEDOWN = 3
Global Const TL_SB_THUMBPOSITION = 4
Global Const TL_SB_THUMBTRACK = 5
Global Const TL_SB_TOP = 6
Global Const TL_SB_BOTTOM = 7
Global Const TL_SB_ENDSCROLL = 8

' AfterEditing Options parameter constants
Global Const TL_EDCANCELLEDBY_USER = &H0
Global Const TL_EDCANCELLEDBY_PROPERTY = &H1

' RequestEditing Options parameter constants
Global Const TL_REQED_LEFT = &H0
Global Const TL_REQED_CENTER = &H1
Global Const TL_REQED_RIGHT = &H2
Global Const TL_REQED_MULTILINE = &H4
Global Const TL_REQED_UPPERCASE = &H8
Global Const TL_REQED_LOWERCASE = &H10
Global Const TL_REQED_PASSWORD = &H20
Global Const TL_REQED_AUTOVSCROLL = &H40
Global Const TL_REQED_AUTOHSCROLL = &H80
Global Const TL_REQED_STDCOLORS = &H100
Global Const TL_REQED_BORDER = &H200
Global Const TL_REQED_VSCROLLER = &H400
Global Const TL_REQED_READONLY = &H800
Global Const TL_REQED_NOMENU = &H4000
Global Const TL_REQED_HSCROLLER = &H2000

' TListFindItem function nFlags parameter constants
Global Const TL_FI_DONTUSECASE = &H1
Global Const TL_FI_RELAXED = &H2
Global Const TL_FI_STARTSWITH = &H4
Global Const TL_FI_BYVALUE = &H8
Global Const TL_FI_BACKDIR = &H100
Global Const TL_FI_SELONLY = &H200

' TList Sorting Styles constants
Global Const TL_SORT_IGNORE_CASE = &H1
Global Const TL_SORT_NUMBERS_SORT = &H2
Global Const TL_SORT_STRING_SORT = &H4
Global Const TL_SORT_GROUP_AT_TOP = &H8
Global Const TL_SORT_GROUP_AT_BOTTOM = &H10

' TList LoadData & SaveData function constants
Global Const TL_IODATA_OK = &H0
Global Const TL_IODATA_ERROR = &H1
Global Const TL_IODATA_FILENOTFOUND = &H2

' TListFastAdd function constants(Options parameter)
Global Const TLFAST_BACKCOLOR = &H1
Global Const TLFAST_FORECOLOR = &H2
Global Const TLFAST_FONTNAME = &H4
Global Const TLFAST_FONTSIZE = &H8
Global Const TLFAST_FONTITALIC = &H10
Global Const TLFAST_FONTBOLD = &H20
Global Const TLFAST_FONTUNDER = &H40
Global Const TLFAST_FONTSTRIKE = &H80
Global Const TLFAST_NOTFONTITALIC = &H100
Global Const TLFAST_NOTFONTBOLD = &H200
Global Const TLFAST_NOTFONTUNDER = &H400
Global Const TLFAST_NOTFONTSTRIKE = &H800
Global Const TLFAST_EXPANDED = &H1000
Global Const TLFAST_NOTEXPANDED = &H2000

'Hit Test
Global Const TLHITTEST_ERROR = &H0
Global Const TLHITTEST_ITEM = &H1
Global Const TLHITTEST_ITEMTEXT = &H2
Global Const TLHITTEST_ITEMCELLPICTURE = &H3
Global Const TLHITTEST_ITEMPICTURE = &H4
Global Const TLHITTEST_ITEMPMPICTURE = &H5
Global Const TLHITTEST_ITEMMARK = &H6
Global Const TLHITTEST_GRIDLINES = &H7
Global Const TLHITTEST_GRIDCELL = &H8
Global Const TLHITTEST_GRIDCELLPICTURE = &H9
Global Const TLHITTEST_GRIDCELLTEXT = &HA


'Multiline constants
Global Const TLMULTILINE_DEFAULT = &H0
Global Const TLMULTILINE_TRUE = &H1
Global Const TLMULTILINE_FALSE = &H2

'Plus/Minus Picture Type Constants
Global Const TLPMPIC_TYPE_SOLVED = &H0
Global Const TLPMPIC_TYPE_PLUS = &H1
Global Const TLPMPIC_TYPE_MINUS = &H2
Global Const TLPMPIC_TYPE_NONE = &H3

'File Mode Constants
Global Const TLFILE_MODE_OPEN_FOR_READ = &H0
Global Const TLFILE_MODE_OPEN_FOR_WRITE = &H1
Global Const TLFILE_MODE_CLOSE = &H2

'Return code SaveLoadData
Global Const TLPROCESS_OK = &H0
Global Const TLPROCESS_FAILED = &H1
Global Const TLPROCESS_FILENOTFOUND = &H2
Global Const TLPROCESS_ALIENFILE = &H3
Global Const TLPROCESS_BADFILEFORMAT = &H4

'
Global Const TLDRAG_STATE_ENTER = &H0
Global Const TLDRAG_STATE_EXIT = &H1
Global Const TLDRAG_STATE_OVER = &H2

'
Global Const TLDRAG_CANCEL = &H0
Global Const TLDRAG_START = &H1
Global Const TLDRAG_END = &H2

'PrintOneStep options flags:
Global Const TL_PRNOS_FULL_EXPAND     = &H4
Global Const TL_PRNOS_BACKGROUND      = &H8
Global Const TL_PRNOS_ABORT_STYLE     = &H10
Global Const TL_PRNOS_GENERATE_EVENTS = &H20
Global Const TL_PRNOS_DO_NOT_INIT     = &H40
Global Const TL_PRNOS_POST_SCRIPT_DC  = &H80



'                         Grid constants

'Resizing Constants
Global Const TLRESIZING_NONE = &H0
Global Const TLRESIZING_COLS = &H1
Global Const TLRESIZING_ROWS = &H2
Global Const TLRESIZING_BOTH = &H3

'AUTOFILL
Global Const TLAUTOFILL_TITLES_NONE = &H0
Global Const TLAUTOFILL_TITLES_NUMBERS = &H1
Global Const TLAUTOFILL_TITLES_CHARACTERS = &H2

'Grid Lines
Global Const GRIDLINES_NONE = &H0
Global Const GRIDLINES_HORIZONTAL = &H1
Global Const GRIDLINES_VERTICAL = &H2
Global Const GRIDLINES_BOTH = &H3

'Modifications property

Global Const TL_MOD_CLICK_BEHAVIOR      = &H1
Global Const TL_MOD_CELLDEF_ALIGNMENT   = &H2
Global Const TL_MOD_LISTINDEX_BEHAVIOR  = &H4
Global Const TL_MOD_INDEX_MINUS_2       = &H40

' TList functions declarations

'** These function calls should be used with the 32 bit OCX
Declare Sub TListFreeBuffer Lib "TLIST5.OCX" (ByVal TreeBuffer As Long)
Declare Function TListIsValidBuffer Lib "TLIST5.OCX" (ByVal TreeBuffer As Long) As Integer
Declare Function TListCopyBuffer Lib "TLIST5.OCX" (ByVal TreeBuffer As Long) As Integer
Declare Function TListPasteBuffer Lib "TLIST5.OCX" (TreeBuffer As Long) As Integer
Declare Function TListIsClipboardFormatAvailable Lib "TLIST5.OCX" () As Integer
Declare Function TListSaveBuffer Lib "TLIST5.OCX" (ByVal TreeBuffer As Long, ByVal nFile As Integer) As Integer
Declare Function TListLoadBuffer Lib "TLIST5.OCX" (TreeBuffer As Long, ByVal nFile As Integer) As Integer


Public Function TListTranslateIndex(tltTree As TList, ByVal nFromIndexMethod As Integer, ByVal nToIndexMethod As Integer, ByVal nFromIndex As Integer) As Integer
    TListTranslateIndex = tltTree.TranslateIndex(nFromIndexMethod, nToIndexMethod, nFromIndex)
End Function

Public Function TListFindItem(tltTree As TList, ByVal FindWhat As String, ByVal nFlags%, ByVal nFromIndex%, ByVal nToIndex%) As Integer
  TListFindItem = tltTree.FindItem(FindWhat, nFlags%, nFromIndex%, nToIndex%)
End Function

Public Function TListFindValue(tltTree As TList, FindWhat As Variant, ByVal nFlags%, ByVal nFromIndex%, ByVal nToIndex%) As Integer
  TListFindValue = tltTree.FindItem(FindWhat, TL_FI_RELAXED Or nFlags%, nFromIndex%, nToIndex%)
End Function

Public Function TListIndexByBM(tltTree As TList, ByVal hTreeBookmark&) As Integer
  TListIndexByBM = tltTree.IndexByBM(hTreeBookmark&)
End Function

Public Function TListIsValidBM(tltTree As TList, ByVal hTreeBookmark&) As Boolean
  TListIsValidBM = tltTree.IsValidBM(hTreeBookmark&)
End Function

Public Function TListGetItemByXY(tltTree As TList, ByVal nX As Integer, ByVal nY As Integer, ByVal nType As Integer) As Integer
  TListGetItemByXY = tltTree.GetItemByXY(nX, nY, nType)
End Function

Public Function TListGetItemRect(tltTree As TList, ByVal nIndex As Integer, ByVal nOpts As Integer, pRect As Integer) As Integer
  TListGetItemRect = tltTree.GetItemRect(nIndex, nOpts, pRect)
End Function

Public Function TListFastAddItem(tltTree As TList, ByVal nShift%, ByVal Text As String, ByVal lOptions As Long) As Integer
  TListFastAddItem = tltTree.FastAddItem(nShift%, Text, lOptions)
End Function

Public Function TListFastAddItemEx(tltTree As TList, ByVal nShift%, ByVal Text As String, ByVal lOptions As Long, ByVal FontName As String, ByVal FontSize%, ByVal BackColor&, ByVal ForeColor&) As Integer
  TListFastAddItemEx = tltTree.FastAddItemEx(nShift%, Text, lOptions, FontName, FontSize%, BackColor&, ForeColor&)
End Function